;================
; Statistiques de salon
;================

alias statf var %f = $fichier(system\data\stat.txt) | if $isid { return %f } | run %f

on *:START:loadstat
on *:EXIT:maint.stat2
on *:CLOSE:@stat:savestat | loadstat
on *:ACTIVE:@stat:window -n @stat

alias -l astat loadstat | aline @stat $$1-
alias -l istat loadstat | iline @stat $1 $$2-
alias -l dstat loadstat | dline @stat $$1-
alias loadstat {
  if !$window(@stat) { 
    window -h @stat
    if $exists($statf) { loadbuf @stat $statf }  
  }
}
alias savestat {
  if $window(@stat) { 
    var %tmp = $puttok($statf,tmp,-1,46) , %statf = $statf
    if $isfile(%tmp) { .remove %tmp }
    savebuf @stat %tmp
    if $isfile(%tmp) && ($line(@stat,0) == $lines(%tmp)) { 
      if $isfile(%statf) { .remove %statf }
      .rename %tmp %statf 
      .remove %tmp 
      .signal save@
    }
  }
}

alias -l stat.sv {
  if ($gettok($1,2,32) < $gettok($2,2,32)) return 1
  if ($gettok($1,2,32) = $gettok($2,2,32)) {
    if ($gettok($1,1,32) < $gettok($2,1,32)) return -1
    if ($gettok($1,1,32) > $gettok($2,1,32)) return 1
  }
  if ($gettok($1,2,32) > $gettok($2,2,32)) return -1
}
alias -l statext {
  tokenize 32 $gettok($1,2,32) $gettok($2,2,32)
  if ($1 > $2) return 1
  if ($1 < $2) return -1
  return 0
}
alias stat.ext {
  var %nc = $iif($+(*,$chr(44),#*) iswm $1,$1,$+($net,$chr(44),$iif($1,#$1,$active)))
  window -c @statext | window -h @statext
  filter -a @stat @statext statext %nc *
  var %l = $line(@statext,0) , %i = 1 , %j = %l , %ctime = $ctime
  if ($2 isnum) {
    var %c = %ctime , %d = $false
    while !%d && (%i < %l) && ($calc(%ctime - $gettok($line(@statext,%i),3,32)) > $2) { 
      if ($v1 <= %c) { var %c = $v1 | inc %i } 
      else { var %d = $true | dec %i }
    }
    if %d { var %j = %i }
    else { 
      var %c = %ctime , %d = $false
      while !%d && (%j > 1) && ($calc(%ctime - $gettok($line(@statext,%j),3,32)) > $2) { 
        if ($v1 <= %c) { var %c = $v1 | dec %j } 
        else { var %d = $true | inc %j }
      }
    }
  }
  var %m = $gettok($line(@statext,%i),2-3,32) $gettok($line(@statext,%j),2-3,32) 
  window -c @statext
  tokenize 32 %m
  if ($prop == min) return $1
  if ($prop == mint) return $2
  if ($prop == max) return $3
  if ($prop == maxt) return $4
  return %m
}
alias updatestat {
  loadstat
  var %chan = $lower($$1) , %c = $+($net,$chr(44),%chan) , %n = $iif($2 isnum,$2,$nick(%chan,0)) , %t = $ctime
  if (%n !isnum) || !%n { return }
  if ($+(*,$chr(44),#*) iswm %c) {
    var %p = %c %n
    if $fline(@stat,%c *) {  
      if $maxdedracy {
        tokenize 32 $stat.ext(%c)
        if (%n < $1) { .signal stat.mini %c %n }
        elseif (%n > $3) { .signal stat.maxi %c %n }
      }
      if $fline(@stat,%p *) { dstat $v1 }
    }
    astat %p %t
  }
  maint.stat
}

alias maint.stat {
  if $1 { .timermaint.stat -o off }
  if !$window(@stat) || $timer(maint.stat) { return } 
  .timermaint.stat -o 1 $iif($maxdedracy,300,1200) noop
  savestat
}

alias stat.oldest {
  tokenize 9 $line(@stat,1)
  if !$prop { return $2 }
  if ($prop == tps) { return $tps($2) }
  var %d = $calc($ctime - $2)
  if ($prop == d) { return %d }
  if ($prop == dure) { return $dure(%d) }
  if ($prop == dure1) { return $dure1(%d) }
}

alias reset.stat clear @stat | savestat

alias reset.stat2 clear @stat2 | clear @stat2! | savestat

alias Stat {
  var %chan = $iif($1,#$1,$active) , %nc = $+($net,$chr(44),%chan)
  if ($status != connected) || !$ischan(%chan) { return }
  maint.stat %nc
  var %ticks = $ticks , %i = 1 , %b = 0 , %f = 0 , %h = 0 , %pg = 0 , %pp = 0 , %pp@ = 0 , %ppc = 0 , %a = 0 , %na = 0 , %-18 = 0 , %18-29 = 0 , %30-39 = 0 , %40-49 = 0 , %50-70 = 0
  var %s = stats , %@s = @ $+ %s , %ns = 0 | if $hget(%s) { hfree %s } | if $window(%s) { window -c %@s } | window -h %@s
  var %fai = statfai , %@fai = @ $+ %fai , %nfai = 0 | if $hget(%fai) { hfree %fai } | if $window(%fai) { window -c %@fai } | window -h %@fai
  var %v = statv , %@v = @ $+ %v , %nv = 0 | if $hget(%v) { hfree %v } | if $window(%v) { window -c %@v } | window -h %@v
  var %domfai = wanadoo.fr sfr.net proxad.net completel.net numericable.fr bbox.fr
  var %nomfai = Orange SFR Free Completel Numricable Bbox
  while $nick(%chan,%i) {
    var %nick = $v1 , %suff = $gettok($ial(%nick).host,-1,46) , %bot = $iif($isrobot(%nick),$true,$false)
    if %suff && (%suff !isnum) && $tld(%suff) { 
      hinc -m %s $upper(%suff) | inc %ns 
      var %dom = $gettok($ial(%nick).host,-2--1,46)
      if $istok(%domfai,%dom,32) && !%bot { hinc -m %fai %dom }
    }
    if %bot { inc %b }
    elseif ($asv(%nick) != $null) {
      var %sexe = $asv(%nick).s
      if (%sexe == F)  { inc %f } | elseif (%sexe == H)  { inc %h }
      var %age = $asv(%nick).age
      if (%age isnum 10-70) { 
        inc %a %age | inc %na 
        if (%age < 18) { inc %-18 } 
        elseif (%age < 30) { inc %18-29 } 
        elseif (%age < 40) { inc %30-39 }  
        elseif (%age < 50) { inc %40-49 }
        else inc %50-70
      }
      if $asv(%nick).v { 
        var %ville = $remove($replace($v1,$chr(32),$chr(160)),$chr(44))
        if (%ville != ...) { hinc -m %v %ville | inc %nv }
      }
    }
    inc %i
  }
  var %n = $nick(%chan,0) , %u = $calc(%n - %b) , %z = $calc(%u - %h - %f) , %hf = $calc(%h + %f) , %moy = $iif(%na,$calc(%a / %na)) , %p = $calc(%pp + %pg) , %si = $calc(%n - %ns)
  if %moy { var %moy1 = $iif(%moy,$floor(%moy)) , %moy2 = $iif(%moy,$floor($calc(12 * (%moy - %moy1)))) }
  var %i = 1 | while $hget(%s,%i).item {
    var %suff = $v1
    aline %@s %suff $hget(%s,%suff)
    inc %i
  }
  var %ls = $line(%@s,0)
  filter -a %@s %@s stat.sv * 
  if %ls { dline %@s 1- $+ %ls }
  var %i = 1 | while $hget(%fai,%i).item {
    var %dom = $v1
    aline %@fai %dom $hget(%fai,%dom)
    inc %i
  }
  var %lfai = $line(%@fai,0) 
  filter -a %@fai %@fai stat.sv * 
  if %lfai { dline %@fai 1- $+ %lfai }
  var %i = 1 | while $hget(%v,%i).item {
    var %ville = $v1
    aline %@v %ville $hget(%v,%ville)
    inc %i
  }
  var %lv = $line(%@v,0)
  filter -a %@v %@v stat.sv * 
  if %lv { dline %@v 1- $+ %lv }
  var %titre = Statistiques du salon %chan , %conn = $point Nombre de connects : %n , %l = $calc($larg(%conn) + 10)
  cadre $tiret2 %titre
  var %x = %n , %y = %n | wecho $event(Info,$tabul($point Nombre de connects :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
  var %x = %b , %y = %n | wecho $event(Info,$tabul($tiret dont Robots :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
  var %x = %u , %y = %n | wecho $event(Info,$tabul($tiret dont Utilisateurs :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))

  var %ctime = $ctime , %min , %max , %minj , %maxj , %mins , %maxs
  window -c @stat1 | window -h @stat1
  filter -a @stat @stat1 statext %nc *
  var %stat1l = $line(@stat1,0) , %min = $gettok($line(@stat1,1),2-3,32) , %max = $gettok($line(@stat1,%stat1l),2-3,32)
  var %i = 1 
  while (%i <= %stat1l) && ($calc(%ctime - $gettok($line(@stat1,%i),3,32)) > 86400) { inc %i }
  if $line(@stat1,%i) { var %minj = $gettok($v1,2-3,32) }
  var %i = %stat1l 
  while (%i >= 1) && ($calc(%ctime - $gettok($line(@stat1,%i),3,32)) > 86400) { dec %i }
  if $line(@stat1,%i) { var %maxj = $gettok($v1,2-3,32) }
  window -c @stat1
  if %min || %max {
    trait $tiret2 %titre
    if %min {
      wecho $event(Info,$point Minimum de connects :)
      var %x = $gettok(%min,1,32) , %y = le $asctime($gettok(%min,2,32),dd/mm/yyyy  HH:nn:ss)
      wecho $event(Info,$tabul($tiret historique :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par(Atteint $iif(%x == %n,actuellement,%y)))
      if %minj {
        tokenize 32 $v1
        var %y1 = $2 , %y = $iif(%y1 == $gettok(%min,2,32),idem,Atteint  $asctime(%y1,HH:nn:ss))
        var %x1 = $1 , %x = $iif(%y1 == $gettok(%min,2,32),idem,%x1)
        wecho $event(Info,$tabul($tiret depuis 1 jour :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($iif(%x == %n,Atteint actuellement,%y)))
      }
    }
    if %max {
      wecho $event(Info,$point Maximum de connects :)
      var %x = $gettok(%max,1,32) , %y = le $asctime($gettok(%max,2,32),dd/mm/yyyy  HH:nn:ss)
      wecho $event(Info,$tabul($tiret historique :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par(Atteint $iif(%x == %n,actuellement,%y)))
      if %maxj {
        tokenize 32 $v1
        var %y1 = $2 , %y = $iif(%y1 == $gettok(%max,2,32),idem,Atteint  $asctime(%y1,HH:nn:ss))
        var %x1 = $1 , %x = $iif(%y1 == $gettok(%max,2,32),idem,%x1)
        wecho $event(Info,$tabul($tiret depuis 1 jour :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($iif(%x == %n,Atteint actuellement,%y)))
      }
    }
  }
  trait $tiret2 %titre
  wecho $event(Info,$point Rpartition des connects par Suffixe :)
  var %i = 1 , %s = $gettok($ial($me).host,-1,46) 
  while $line(%@s,%i).item {
    tokenize 32 $v1
    var %x = $2 , %y = %n , %w = $1 $iif($tld($1) != $1,$par($v1))
    wecho $event(Info,$tabul($tiret $iif(%s == $1,$gras(%w),%w) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    inc %i
  }
  if (%si > 0) { 
    var %x = $v1 , %y = %n , %w = Inconnu 
    wecho $event(Info,$tabul($tiret $iif((%s isnum) || !$tld(%s),$gras(%w),%w) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %)) 
  }
  if %lfai {
    trait $tiret2 %titre
    wecho $event(Info,$point Rpartition des Utilisateurs par FAI (France seulement) :)
    var %i = 1 , %monfai = $iif($findtok(%domfai,$gettok($ial($me).host,-2--1,46),1,32),$gettok(%nomfai,$v1,32))
    while $line(%@fai,%i).item {
      tokenize 32 $v1
      var %x = $2 , %y = %u , %w = $gettok(%nomfai,$findtok(%domfai,$1,1,32),32)
      wecho $event(Info,$tabul($tiret $iif(%monfai == %w,$gras(%w),%w) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
      inc %i
    }
  }
  if %h || %f {
    trait $tiret2 %titre
    wecho $event(Info,$point Rpartition des Utilisateurs par Sexe :)
    var %x = %h , %y = %u | wecho $event(Info,$tabul($tiret $iif($asv($me).s == H,$gras(Hommes),Hommes) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %) $par($round($calc(100 * %x / %hf),2) %))
    var %x = %f , %y = %u | wecho $event(Info,$tabul($tiret $iif($asv($me).s == F,$gras(Femmes),Femmes) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %) $par($round($calc(100 * %x / %hf),2) %))
    if %z { var %x = %z , %y = %u | wecho $event(Info,$tabul($tiret $iif($asv($me).s == ?,$gras(Inconnus),Inconnus) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %)) }
  }
  if %18-29 || %30-39 || %40-49 || %50-70 {
    trait $tiret2 %titre
    wecho $event(Info,$point Rpartition des Utilisateurs par ge :)
    var %x = %-18 , %y = %na | wecho $event(Info,$tabul($tiret $iif($asv($me).age < 18,$gras(Moins de 18 ans),Moins de 18 ans) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    var %x = %18-29 , %y = %na | wecho $event(Info,$tabul($tiret $iif(($asv($me).age >= 18) && ($asv($me).age < 30),$gras(18  29 ans),18  29 ans) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    var %x = %30-39 , %y = %na | wecho $event(Info,$tabul($tiret $iif(($asv($me).age >= 30) && ($asv($me).age < 40),$gras(30  39 ans),30  39 ans) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    var %x = %40-49 , %y = %na | wecho $event(Info,$tabul($tiret $iif(($asv($me).age >= 40) && ($asv($me).age < 50),$gras(40  49 ans),40  49 ans) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    var %x = %50-70 , %y = %na | wecho $event(Info,$tabul($tiret $iif(($asv($me).age >= 50) && ($asv($me).age <= 70),$gras(50  70 ans),50  70 ans) :,$calc(%l - $larg(%x))).c $+ $+(04,%x,02) $par($round($calc(100 * %x / %y),2) %))
    if %moy { wecho $event(Info,$tabul(Moyenne d'ge :,$calc(%l - $larg(%moy1))).c $+ $+(04,%moy1,02) ans $iif(%moy2,et $v1 mois)) }
  }
  if %lv {
    trait $tiret2 %titre
    wecho $event(Info,$point Rpartition des Utilisateurs par Lieu $cro(%lv) :)
    var %i = 1 , %maville = $asv($me).v | while (%i <= %lv) {
      tokenize 32 $line(%@v,%i)
      tokenize 32 $iif($1 == %maville,$gras($1),$1) $2
      if $fline(%@v,$2 *) { rline %@v $v1 $addtok($line(%@v,$v1),$1,32) }
      else aline %@v $2 $1
      inc %i
    }
    if %lv { dline %@v 1- $+ $v1 } | var %lv = $line(%@v,0)
    var %i = 1 , %x | while $line(%@v,%i) {
      tokenize 32 $v1
      tokenize 32 $1 $replacex($2-,$chr(32),$chr(44) $+ $chr(32))
      if %x { var %x = %x $tiret }
      var %j = 1 | while $gettok($2-,%j,32) {
        var %x = %x $v1 $iif(%j == $numtok($2-,32),$par($+(04,$1,02)))
        if ($larg(%x).c > 450) || ((%i == %lv) && (%j == $numtok($2-,32))) { wecho $event(Info,%x) | var %x }
        inc %j
      }
      inc %i
    }
  }
  trait $tiret2 %titre
  if $maxdedracy { wecho $event(Info,Statistiques gnres en $dure2($calc(($ticks - %ticks) / 1000),2)) }
  if $hget(%s) { hfree %s } | if $window(%@s) { window -c %@s }
  if $hget(%fai) { hfree %fai } | if $window(%@fai) { window -c %@fai }
  if $hget(%v) { hfree %v } | if $window(%@v) { window -c %@v }
}

alias stat.conv {
  var %i = 1 , %f = @stat , %g = $fichier(system\data\statchan) , %w = @statconv
  if !$isfile(%g) { return }
  window -c %w | window -h %w 
  while $line(%f,%i) {
    tokenize 9 $v1
    aline %w $iif($1 isnum,$read(%g,$1),$1) $2-
    inc %i
  }
  .remove $statf
  .remove %g
  savebuf %w $statf
  window -c @stat
  loadstat
  window -c %w
}
;supprime les stats des salons d'un rseau
alias delstatr {
  var %j = 1 | while $gettok($1-,%j,32) {
    var %w = @delstatr , %r = $v1
    window -c %w | window -h %w
    filter -n @stat %w $+(%r,$chr(44),*)
    var %i = $line(%w,0) | while (%i >= 1) {
      dstat $gettok($line(%w,%i),1,32)
      dec %i
    }
    window -c %w
    inc %j
  }
  savestat
}
;supprime les stats d'un salon
alias delstat {
  var %j = 1 | while $gettok($1-,%j,32) {
    var %a = $v1 , %w = @delstat , %c = $iif($+(*,$chr(44),#*) iswm %a,$v2,$+($net,$chr(44),$iif(%a,$v1,$active)))
    ;wecho %a  %c 
    window -c %w | window -h %w
    filter -n @stat %w %c *
    var %i = $line(%w,0) | while (%i >= 1) {
      dstat $gettok($line(%w,%i),1,32)
      dec %i
    }
    window -c %w
    inc %j
  }
  savestat
}
;supprime les stats des salons non joints depuis + de 6 mois
alias maint.stat2 {
  var %i = 1 , %w = @stat , %h = maintstat2
  if $hget(%h) { hfree %h }
  while $line(%w,%i) {
    tokenize 32 $v1
    var %a = $hget(%h,$1)
    if !%a || ($3 > %a) { hadd -m %h $1 $3 }
    inc %i
  }
  var %i = 1 , %s = $calc(86400 * 26 * 7) , %x | while $hget(%h,%i).item {
    var %a = $v1 , %b = $hget(%h,%a) , %d = $calc($ctime - %b)
    if (%d > %s) var %x = $addtok(%x,%a,32)
    inc %i
  }
  delstat %x 
  if $hget(%h) { hfree %h }
}
alias statr {
  var %i = 1 , %w = @stat , %h = statr , %h2 = statr2
  if $hget(%h) { hfree %h }
  while $line(%w,%i) {
    tokenize 32 $v1
    var %r = $gettok($1,1,44) , %a = $hget(%h,%r)
    if !%a || ($3 > %a) { hadd -m %h %r $3 }
    inc %i
  }
  var %i = 1 , %x | while $hget(%h,%i).item {
    var %a = $v1 , %b = $hget(%h,%a) , %x = %x %b , %y = %y %a
    inc %i
  }
  var %x = $sorttok(%x,32,nr) , %i = 1 | while $gettok(%x,%i,32) {
    var %a = $v1 , %b = $hfind(%h,%a,1).data , %y = $remtok(%y,%b,1,32) , %d = $calc($ctime - %a)
    if (%i == 1) wecho $event(Info,Anciennet des statistiques par rseau :)
    wecho $event(Info,$chr(124) %b  $+ $dure1(%d))
    inc %i
  }
  if $hget(%h) { hfree %h }
}
